%define python2_sitelib	%(%{__python2} -Esc "from distutils.sysconfig import get_python_lib; print(get_python_lib(False))")
%define	python3_sitelib	%(%{__python3} -Esc "from distutils.sysconfig import get_python_lib; print(get_python_lib(False))")
%define	debug_package %{nil}
%define py_setup setup.py

%global         with_python2 0

%if 0%{?fedora} || 0%{?centos} >= 7
%global         with_python3 1
%else
%global         with_python3 0
%endif

%if 0%{?centos}0%{?amzn} == 70
%define python3_pkgversion 36
%endif

%if 0%{?fedora} >= 35 || 0%{?centos} >= 9
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^python3.*dist.*$
%endif

Summary:	Library that provides read-only access to Windows Registry objects
Name:		dfwinreg
Version:	20221218
Release:	1%{?dist}
Group:		System Environment/Libraries
License:	LGPL
Source:		%{name}-%{version}.tar.gz
URL:		https://github.com/log2timeline/dfwinreg/wiki
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
dfWinReg, or Digital Forensics Windows Registry, provides read-only
access to Windows Registry objects. The goal of dfWinReg is to provide a
generic interface for accessing Windows Registry objects that resembles
the Registry key hierarchy as seen on a live Windows system.

dfWinReg originates from the Plaso project and is also based on ideas
from the winreg-kb project. It was largely rewritten and made into a
stand-alone project to provide more flexibility and allow other projects
to make use of Windows Registry functionality.

%if 0%{?with_python2}
%package -n python2-%{name}
Summary:	Digital Forensics Windows Registry (dfWinReg).
Obsoletes:	python-dfwinreg < %{version}
Provides:	python-dfwinreg = %{version}
Obsoletes:	dfwinreg < %{version}
Provides:	dfwinreg = %{version}
%if 0%{?fedora} <= 27
Requires:       PyYAML			>= 3.10
%endif
%if 0%{?fedora} >= 28
Requires:       python2-pyyaml		>= 3.10
%endif
Requires:	libregf-python2 >= 20150315
Requires:	python2-dfdatetime >= 20160814
Requires:	python2-dtfabric >= 20170524

%description -n python2-%{name}
dfWinReg, or Digital Forensics Windows Registry, provides read-only
access to Windows Registry objects. The goal of dfWinReg is to provide a
generic interface for accessing Windows Registry objects that resembles
the Registry key hierarchy as seen on a live Windows system.
%endif

%if 0%{?with_python3}
%package -n python%{python3_pkgversion}-%{name}
Summary:	Digital Forensics Windows Registry (dfWinReg).
%if 0%{?fedora} <= 27
Requires:       python%{python3_pkgversion}-PyYAML >= 3.10
%endif
%if 0%{?fedora} >= 28
Requires:       python%{python3_pkgversion}-pyyaml >= 3.10
%endif
Requires:	libregf-python%{python3_pkgversion} >= 20150315
Requires:	python%{python3_pkgversion}-dfdatetime >= 20160814
Requires:	python%{python3_pkgversion}-dtfabric >= 20170524
BuildRequires:	python%{python3_pkgversion}
BuildRequires:	python%{python3_pkgversion}-devel
BuildRequires:	python%{python3_pkgversion}-setuptools

%if ! 0%{?with_python2}
Obsoletes:	python2-%{name} < %{version}
%endif

%description -n python%{python3_pkgversion}-%{name}
dfWinReg, or Digital Forensics Windows Registry, provides read-only
access to Windows Registry objects. The goal of dfWinReg is to provide a
generic interface for accessing Windows Registry objects that resembles
the Registry key hierarchy as seen on a live Windows system.
%endif

%prep
%autosetup -n %{name}-%{version}

%build
%if 0%{?with_python2}
%py2_build
%endif
%if 0%{?with_python3}
%py3_build
%endif

%install
%if 0%{?with_python2}
%py2_install
%endif
%if 0%{?with_python3}
%py3_install
%endif
rm -rf %{buildroot}%{_docdir}/%{name}

%clean
rm -rf ${RPM_BUILD_ROOT}

%if 0%{?with_python2}
%files -n python2-%{name}
%license LICENSE
%doc README
%{python2_sitelib}/dfwinreg
%{python2_sitelib}/dfwinreg*.egg-info
%endif

%if 0%{?with_python3}
%files -n python%{python3_pkgversion}-%{name}
%license LICENSE
%doc README
%{python3_sitelib}/dfwinreg
%{python3_sitelib}/dfwinreg*.egg-info
%endif

%changelog
* Sun Dec 18 2022 Lawrence R. Rogers <lrr@cert.org> 20221218-1
* Release 20221218-1
	Version from 20221218

* Tue Dec  7 2021 Lawrence R. Rogers <lrr@cert.org> 20211207-1
* Release 20211207-1
	Version from 20211207

* Tue Oct  6 2020 Lawrence R. Rogers <lrr@cert.org> 20201006-1
* Release 20201006-1
	Version from 20201006

* Fri Oct  2 2020 Lawrence R. Rogers <lrr@cert.org> 20201002-1
* Release 20201002-1
	Version from 20201002

* Mon Sep 28 2020 Lawrence R. Rogers <lrr@cert.org> 20200928-1
* Release 20200928-1
	Version from 20200928

* Sun Sep 27 2020 Lawrence R. Rogers <lrr@cert.org> 20200927-1
* Release 20200927-1
	Version from 20200927

* Wed Apr 15 2020 Lawrence R. Rogers <lrr@cert.org> 20200415-1
* Release 20200415-1
	Version from 20200415

* Tue Feb  4 2020 Lawrence R. Rogers <lrr@cert.org> 20200121-2
* Release 20200121-2
	Python 3 package now obsoletes Python 2 package.

* Tue Jan 21 2020 Lawrence R. Rogers <lrr@cert.org> 20200121-1
* Release 20200121-1
	Version 20200121
	Python 2 is now optional and off by default.

* Sun Jul 14 2019 Lawrence R. Rogers <lrr@cert.org> 20190714-1
* Release 20190714-1
	Version as of 20190714

* Sun May 19 2019 Lawrence R. Rogers <lrr@cert.org> 20190517-2
* Release 20190517-2
	Version 20190517-2: Uses python3_pkgversion for the current version of Python 3.

* Fri May 17 2019 Lawrence R. Rogers <lrr@cert.org> 20190517-1
* Release 20190517-1
        Version as of 20190517

* Fri Mar 29 2019 Lawrence R. Rogers <lrr@cert.org> 20190329-1
* Release 20190329-1
        Version as of 20190329

* Mon Mar 11 2019 Lawrence R. Rogers <lrr@cert.org> 20190311-1
* Release 20190311-1
        Version as of 20190311

* Tue Jan 29 2019 Lawrence R. Rogers <lrr@cert.org> 20190122-3
* Release 20190122-3
        Version as of 20190122
	Changed YAML dependencies.

* Tue Jan 29 2019 Lawrence R. Rogers <lrr@cert.org> 20190122-2
* Release 20190122-2
        Version as of 20190122
	Updated dependencies to specify python 2 or python 3.

* Thu Jan 24 2019 Lawrence R. Rogers <lrr@cert.org> 20190122-2
* Release 20190122-2
	Version 20190122
	Build for Python 2 and 3

* Tue Jan 22 2019 Lawrence R. Rogers <lrr@cert.org> 20190122-1
* Release 20190122-1
	Version 20190122

* Thu Jul 12 2018 Lawrence R. Rogers <lrr@cert.org> 20180712-1
* Release 20180712-1
	Version 20180712

* Thu Mar 29 2018 Lawrence R. Rogers <lrr@cert.org> 20180329-1
* Release 20180329-1
	Version 20180329

* Thu Jul  6 2017 Lawrence R. Rogers <lrr@cert.org> 20170706-1
* Release 20170706-1
	Version 20170706

* Thu Apr 28 2016 Lawrence R. Rogers <lrr@cert.org> 20160428-1
* Release 20160428-1
	Version 20160428

* Sat Jan 16 2016 Lawrence R. Rogers <lrr@cert.org> 20160116-1
* Release 20160116-1
`	Version 20160116
